<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>JSDoc: Source: strikeRate.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>

<body>

<div id="main">

    <h1 class="page-title">Source: strikeRate.js</h1>

    



    
    <section>
        <article>
            <pre class="prettyprint source linenums"><code>/**
 * This moudule accepts matches and deliveries data to return strike rate of the provided player for all seasons
 * @module strikeRate
 */

/**
 *
 * @param {Array.&lt;Object>} matchesData parsed JSON data of matches
 * @param {Array.&lt;Object>} deliveriesData parsed JSON data of deliveries
 * @param {string} player Player name whose strike rate to find
 * @returns {Object} strike rate of the provided player for all seasons
 */

const strikeRate = (matchesData, deliveriesData, player = "V Kohli") => {
  if (!Array.isArray(matchesData) || !Array.isArray(deliveriesData)) return {};

  const seasonWithMatchId = matchesData.reduce((acc, match) => {
    acc[match.id] = match.season;

    return acc;
  }, {});

  const seasonWiseBatsman = deliveriesData
    .filter((delivery) => delivery.batsman === player)
    .reduce((acc, delivery) => {
      if (acc[delivery.batsman] === undefined) {
        acc[delivery.batsman] = {};
      }

      if (
        acc[delivery.batsman][seasonWithMatchId[delivery.match_id]] ===
        undefined
      ) {
        acc[delivery.batsman][seasonWithMatchId[delivery.match_id]] = {
          runs: 0,
          balls: 0,
        };
      }

      acc[delivery.batsman][seasonWithMatchId[delivery.match_id]].balls += 1;
      acc[delivery.batsman][seasonWithMatchId[delivery.match_id]].runs +=
        parseInt(delivery.batsman_runs);

      acc[delivery.batsman][seasonWithMatchId[delivery.match_id]].economy = (
        (acc[delivery.batsman][seasonWithMatchId[delivery.match_id]].runs *
          100) /
        acc[delivery.batsman][seasonWithMatchId[delivery.match_id]].balls
      ).toFixed(2);

      return acc;
    }, {});

  return seasonWiseBatsman;
};

module.exports = strikeRate;
</code></pre>
        </article>
    </section>




</div>

<nav>
    <h2><a href="index.html">IPL Project</a></h2><h3>Modules</h3><ul><li><a href="module-bestSuperoverEconomy.html">bestSuperoverEconomy</a></li><li><a href="module-calcEconomy.html">calcEconomy</a></li><li><a href="module-config.html">config</a></li><li><a href="module-economicalBowlers.html">economicalBowlers</a></li><li><a href="module-extraRunsPerTeam.html">extraRunsPerTeam</a></li><li><a href="module-matchesInGivenYear.html">matchesInGivenYear</a></li><li><a href="module-matchesPerYear.html">matchesPerYear</a></li><li><a href="module-matchesWonPerTeam.html">matchesWonPerTeam</a></li><li><a href="module-matchesWonWithToss.html">matchesWonWithToss</a></li><li><a href="module-playerDismissed.html">playerDismissed</a></li><li><a href="module-playerOfTheMatch.html">playerOfTheMatch</a></li><li><a href="module-saveOutput.html">saveOutput</a></li><li><a href="module-strikeRate.html">strikeRate</a></li></ul>
</nav>

<br class="clear">

<footer>
    Documentation generated by <a href="https://github.com/jsdoc/jsdoc">JSDoc 3.6.7</a> on Wed May 26 2021 15:19:05 GMT+0530 (India Standard Time)
</footer>

<script> prettyPrint(); </script>
<script src="scripts/linenumber.js"> </script>
</body>
</html>
